#include <%<driver.name>_P.h>
#include <linux/mm.h>
#include <linux/sysctl.h>



#if LINUX_VERSION_CODE >= 131587
#define LDDK_SYSHNDL_GET_LINE while (len < *lenp) { \
			          if(get_user(c, p++)) \
				      return -EFAULT; \
			        if (c == 0 || c == '\n') \
				break; \
			        len++; } 

#define LDDK_FROMIO(a,b,c) if(copy_from_user(a, b, c)) \
			         return -EFAULT;

#define LDDK_TOIO(a,b,c) if(copy_to_user(a, b, c)) \
			         return -EFAULT;



#else

#define LDDK_SYSHNDL_GET_LINE while (len < *lenp && (c = get_user(p++)) != 0 && c != '\n') len++; 

#if LINUX_VERSION_CODE > 0x20100
#define LDDK_FROMIO(a,b,c) memcpy_fromio(a,b,c)
#define LDDK_TOIO(a,b,c) memcpy_toio(a,b,c)
#else
#define LDDK_FROMIO(a,b,c) memcpy_fromfs(a,b,c)
#define LDDK_TOIO(a,b,c) memcpy_tofs(a,b,c)
#endif
#endif



















#define return(a) DBGout();return(a)

int %<sysctl.handler.name> ( ctl_table *table, int write, struct file *filp,
		    void *buffer, size_t *lenp) {
DBGin("%<sysctl.handler.name>");
{
%<sysctl.handler.code>
}
DBGout();
}